<?php
/**
 * Zeigt alle Einträge von der Tabelle acl der Datenbank an
 * 
 * @author Miguel Palmer <mp@beronet.com>
 */
class Acl {

	/**
	 *
	 * @var beroConf Instance root db
	 */
	private $bc;

	function __construct() {
		require_once('/usr/fallback/beroConf.php');
		$this->bc = new beroConf('root');
	}

	function allowLan() {
		$excludelan = $this->bc->get("root", "excludelan");
		($excludelan == 1) ? $checked = "" : $checked = "checked";
		return $checked;
	}

	private function _save() {
		$this->bc->set("root", "excludelan", $_POST['allowlan']);
		return Helper::activate(1, true, $_GET['m'], ACTIVATE);
	}

	/**
	 * Die einträge der ACL Tabelle werden formatiert angezeigt
	 * 
	 * @return string HTML Inhalt
	 */

	function display() {

		include "./includes/functions.php";
		//Das Objekt funktions wird erzeugt um später die Navigationsleiste zu erzeugen.
		$functions = new functions();

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		$start = $_GET['start'];
		$order = $_GET['order'];
		$sort = $_GET['sort'];

		$ba = new beroAri();

		$span = 15;
		$query = $ba->select('SELECT * FROM acl');
		$record_count = sqlite_num_rows($query);
		$test = $record_count / $span;
		$test = (int) $test;
		if ($record_count == 0) {
			$next_add = 0;
		} else {
			$next_add = ($test * $span);
		}

		$start = $start == '' ? 0 : $start;
		$order = $order;
		$sort = $sort;
		$name = "ACL_TITLE_DIS";
		include('./includes/header.php');
		$acl_table = $this->dynamic_table();
		ob_start();
		?>
		<script>
			function del(table, option) {
				conf = confirm('<? echo ACL_DELETE_MESS1_DIS ?>? ');
				if (conf == false) {
					return false;
				} else {
					window.location = './misc/delete.php?m=<? echo $_GET['m'] ?>&id=' + option + '&table=' + table;
				}
			}
		</script>
		<div class='modal fade bs-example-modal-lg' id='acl-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			<div class='modal-dialog modal-lg'>
				<div class='modal-content'>
					<div class='modal-header'>
						<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
						<h4 class='modal-title' id='myModalLabel'><? echo ACL_TITLE_DIS ?></h4>
					</div>
					<div class='modal-body'>
					</div>
				</div>
			</div>
		</div>
		<br>
		<div id='container'>
			<? echo $acl_table ?>
		</div>
		<br>
		<div class='text-center'>
			<a href='modules/Acl/acl_popup.php?start=<? echo $next_add ?>' role='button' data-remote='false' data-toggle='modal' data-target='#acl-popup' class='btn btn-default'>
				<? echo BUTTON_ADD ?>
			</a>
		</div>
		<script type="text/javascript">
			$('#acl-popup').on('show.bs.modal', function (e) {
				var link = $(e.relatedTarget);
				$('.modal-body').load(link.attr('href'));
			});
		</script>
		<?php
		$ba = new beroAri();

		//Erzeugung der Navigationsleiste.
		$query = $ba->select('SELECT * FROM acl');
		$record_count = sqlite_num_rows($query);
		$url_opts = array();
		$url_opts['sort'] = $sort;
		$url_opts['order'] = $order;
		?>
		<div class='text-center'>
			<? echo $functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count) ?>
		</div>


		<?php
		if (isset($_POST['allowlan'])) {
			echo $this->_save();
		}
		?>

		<br>
		<br>
		<form action='' class='allow form-horizontal' method='POST'>
			<input type=hidden name=m value='<? echo $m ?>'>
			<div class="form-group">
				<label for='allowlan' class='col-sm-7 control-label'><? echo ACL_ALLOW_LAN_DIS ?></label>
				<div class='col-sm-4'>
					<input type='hidden' name='allowlan' value='1'>
					<input type='checkbox' name='allowlan' id='allowcheck' value='0' <? echo $this->allowLan() ?>>
					<div id='warning_allowlan' class="text-danger"></div>
				</div>
			</div>
			
			<table class='table table-striped table-bordered' style='max-width:350px; margin:auto;'>
				<div class="text-center">
					<button type='submit' class='btn btn-default' onclick='selectall();'><? echo BUTTON_SAVE ?></button>
				</div>
				</td>
				</tr>
			</table>
			<br>
		</form>
		<script type="text/javascript">
			$('#allowcheck').change(function () {
				if ($('#allowcheck').is(':checked') == false)
					$('#warning_allowlan').html('<? echo ACL_MESSAGE_DIS ?>');
				else
					$('#warning_allowlan').html('');
			});
		</script>
		<?php
		$ret .= ob_get_clean();

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/**
	 * Liefert den HTML Code für die Tabelle
	 * 
	 * @return string HTLM code für die Tabelle
	 */

	function dynamic_table() {
		//ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$bc = new beroConf('root');
		
		require_once("./includes/lang.php");
		$start = $_GET['start'];

		//Das Header der Tabelle sind die Spaltennamen von acl
		$columns = $ba->column_type('acl');
		$i = 0;

		if ($bc->get('root', 'lan-mode') == 'lan-wan') {
			$columnsToShow = array("protocol", "dest_port", "address", "netmask", "stack");
			$colName = array("protocol" => ACL_PROTOCOL_DIS, "dest_port" => ACL_DEST_PORT_DIS, "address" => ACL_ADDRESS_DIS, "netmask" => ACL_NETMASK_DIS, "stack" => "Stack");
		}
		else {
			$columnsToShow = array("protocol", "dest_port", "address", "netmask");
			$colName = array("protocol" => ACL_PROTOCOL_DIS, "dest_port" => ACL_DEST_PORT_DIS, "address" => ACL_ADDRESS_DIS, "netmask" => ACL_NETMASK_DIS);
		}
		
		foreach ($columns as $column => $type) {
			if (in_array($column, $columnsToShow))
				$cols .= "<th>" . $colName[$column] . "</th>";
		}

		/* Die Einträge werden von der Tabelle acl gelesen, formatiert und in einer
		  Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete */
		$page = (($start / 15) + 1);
		if (!$start)
			$start = 0;
		$id = 0;
		$ports = array(-1 => "SIP", 
			-2 => "SIP-TLS", 
			80 => "HTTP", 
			443 => "HTTPS", 
			54322 => "Telnet", 
			22 => "SSH", 
			161 => "SNMP", 
			162 => "SNMP-Trap", 
			65001 => "bfdetect", 
			"all" => "All");
		$protocol = array("" => "All", "udp" => "UDP", "tcp" => "TCP");
		$stack= array("" => "ANY", "LAN" => "LAN", "WAN" => "WAN");
		for ($j = 1; $j <= $page; $j++) {
			$query = $ba->select('SELECT * FROM acl ORDER BY id asc limit 15 offset ' . $start);
			$rows = '';
			while ($entry = $ba->fetch_array($query)) {
				$rows .= "<tr>";
				for ($i = 0; $i < (count($columnsToShow)); $i++) {
					$col_name = $columnsToShow[$i];
					if ($col_name == "dest_port" && (array_key_exists($entry[$col_name], $ports)))
						$entry[$col_name] = $ports[$entry[$col_name]];
					elseif (($col_name == "protocol" && (array_key_exists($entry[$col_name], $protocol))))
						$entry[$col_name] = $protocol[$entry[$col_name]];
					elseif (($col_name == "stack" && (array_key_exists($entry[$col_name], $stack))))
						$entry[$col_name] = $stack[$entry[$col_name]];
					$rows .= "<td>" . $entry[$col_name] . "</td>";
				}
				$id = $entry['id'];
				$rows .= "<td class='buttons'>
				<a href='modules/Acl/acl_popup.php?id=" . $id . "' data-remote='false' data-toggle='modal' data-target='#acl-popup' class='popup_download'>
					<img src='./includes/images/modify.png'>
				</a>&nbsp;
				<a class='popup_download' onclick=\"del('acl','" . $id . "');\">
            	    <img src='./includes/images/delete.png'>
				</a>
				</td></tr>";
			}
		}

		$table = "<table class='table table-striped table-bordered' id='table' style='max-width:600px; margin:auto;'>"
			. "<tr>" 
			. $cols 
			. "<th></th>"
			. "</tr>"
			. $rows 
			. "</table>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle acl der Datenbank
		return $table;
	}

}
?>
